#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "gui.h"

static GtkWidget *fileload = NULL;
static GtkWidget *filesave = NULL;
static buffer *buffer_to_be_saved;


static void 
file_dialog_show (GtkWidget *filesel)
{
/*   menus_set_sensitive ("<Toolbox>/File/Open", FALSE); */
/*   menus_set_sensitive ("<Image>/File/Open", FALSE); */
/*   menus_set_sensitive ("<Image>/File/Save", FALSE); */
/*   menus_set_sensitive ("<Image>/File/Save as", FALSE); */

  gtk_widget_show (filesel);
}

static void
file_dialog_hide (GtkWidget *filesel)
{
  gtk_widget_hide (filesel);

/*   menus_set_sensitive ("<Toolbox>/File/Open", TRUE); */
/*   menus_set_sensitive ("<Image>/File/Open", TRUE); */
/*   menus_set_sensitive ("<Image>/File/Save", TRUE); */
/*   menus_set_sensitive ("<Image>/File/Save as", TRUE); */
}

static void
file_cancel_callback (GtkWidget *w,
                      gpointer   client_data)
{
  file_dialog_hide (client_data);
}

static void
file_delete_callback (GtkWidget *w,
                      GdkEvent *e,
                      gpointer client_data)
{
  file_cancel_callback (w, client_data);
}

static void
file_save_ok_callback (GtkWidget *w,
                       gpointer   client_data)
{
  GtkFileSelection *fs;
  char* filename;

  fs = GTK_FILE_SELECTION (client_data);
  filename = gtk_file_selection_get_filename (fs);
  buffer_save_ml(buffer_to_be_saved, filename);
  file_dialog_hide(filesave);
}

void 
save_callback (GtkWidget *widget, gpointer *data)
{
  if(!filesave) {
    filesave = gtk_file_selection_new("Save Buffer As");
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(filesave)->cancel_button), 
			"clicked",(GtkSignalFunc)file_cancel_callback, 
			filesave);
    gtk_signal_connect (GTK_OBJECT(filesave),"delete_event",
			(GtkSignalFunc) file_delete_callback, filesave);
    gtk_signal_connect (GTK_OBJECT(GTK_FILE_SELECTION (filesave)->ok_button), "clicked", (GtkSignalFunc) file_save_ok_callback, filesave);

  }    
  buffer_to_be_saved = (buffer *) data;
  file_dialog_show(filesave);
}

static void
file_load_ok_callback (GtkWidget *w,
                       gpointer   client_data)
{
  GtkFileSelection *fs;
  char* filename;

  fs = GTK_FILE_SELECTION (client_data);
  filename = gtk_file_selection_get_filename (fs);
  window_new(buffer_load_ml(filename));
  file_dialog_hide(fileload);
}

void load_callback (GtkWidget *widget, gpointer *data)
{
  if(!fileload) {
    fileload = gtk_file_selection_new("Load Buffer");
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(fileload)->cancel_button), 
			"clicked",(GtkSignalFunc)file_cancel_callback, 
			fileload);
    gtk_signal_connect (GTK_OBJECT (fileload), "delete_event",
			(GtkSignalFunc) file_delete_callback, fileload);
    gtk_signal_connect (GTK_OBJECT(GTK_FILE_SELECTION(fileload)->ok_button), 
			"clicked", (GtkSignalFunc) file_load_ok_callback, fileload);

  }    
  file_dialog_show(fileload);
}


